//+------------------------------------------------------------------+
//|                                             fsiTrendDetector.mq4 |
//|                              Copyright  2008, Forex-support.net |
//|                                     http://www.forex-support.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Forex-support.net"
#property link      "http://www.forex-support.net"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 DarkSalmon
//---- input parameters
extern int       bulls_period=21;
extern int       bulls_price=0;
extern int       bulls_ma_period=8;
extern int       bulls_ma_price=MODE_SMMA;

extern int       bears_period=21;
extern int       bears_price=0;
extern int       bears_ma_period=8;
extern int       bears_ma_price=MODE_SMMA;

extern int       digits = 6;

//---- buffers
double aTrendLong[];
double aTrendShort[];
double aSignalMA[];
double aBulls[];
double aBullsMA[];
double aBears[];
double aBearsMA[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators


   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,aTrendLong);
   
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,aTrendShort);
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,aSignalMA);
   
   SetIndexStyle(3,DRAW_NONE);
   SetIndexBuffer(3,aBulls);
   
   SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(4,aBullsMA);
   
   SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(5,aBears);
   
   SetIndexStyle(6,DRAW_NONE);
   SetIndexBuffer(6,aBearsMA);
   
   IndicatorDigits(digits);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int    counted_bars=IndicatorCounted();
//----
    int limit=Bars-counted_bars;
    
    double bears,bulls,delta;
  
    for(int i=limit; i>=0; i--)
    {
      aBears[i] = iBearsPower(NULL,0,bears_period,bears_price,i);
      aBulls[i] = iBullsPower(NULL,0,bulls_period,bulls_price,i);
    }

    

    for(i=limit; i>=0; i--)
    {
      aBearsMA[i] = iMAOnArray(aBears,Bars,bears_ma_period,1,bears_ma_price,i);
      aBullsMA[i] = iMAOnArray(aBulls,Bars,bulls_ma_period,1,bulls_ma_price,i); 
    }
    
    for(i=limit; i>=0; i--)
    {
     delta = aBearsMA[i] + aBullsMA[i];
     aSignalMA[i] = delta;
     aTrendLong[i]=0;
     aTrendShort[i]=0;
     if (delta>0) aTrendLong[i]=delta;
      else
     if (delta<0) aTrendShort[i]=delta;     
    }

   return(0);
  }
  
//+------------------------------------------------------------------+